<?php

namespace App\Domain\Catalogs\Actions;

use App\Domain\Catalogs\Models\Catalog;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;
use App\Exceptions\IllegalOperationException;

class DeleteCatalogAction
{
    use AppliesToAggregate;

    public function execute(int $catalogId): void
    {
        $this->delete($catalogId, function (Catalog $catalog) {

            throw_if(
                $catalog->catalogItems()->exists(),
                IllegalOperationException::class,
                "Catalog {$catalog->id} {$catalog->name} contains connected catalog items. Deletion is restricted."
            );
        });
    }

    protected function createModel(): Model
    {
        return new Catalog();
    }
}
