<?php

namespace App\Domain\Catalogs\Actions;

use App\Domain\Catalogs\Models\CatalogItem;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;
use App\Exceptions\IllegalOperationException;

class DeleteCatalogItemAction
{
    use AppliesToAggregate;

    public function execute(int $catalogId): void
    {
        $this->delete($catalogId, function (CatalogItem $catalogItem) {

            throw_if(
                $catalogItem->children()->exists(),
                IllegalOperationException::class,
                "Catalog item {$catalogItem->id} {$catalogItem->name} contains connected catalog items. Deletion is restricted."
            );
        });
    }

    protected function createModel(): Model
    {
        return new CatalogItem();
    }
}
