<?php

namespace App\Domain\Catalogs\Models\Tests\Factories;

use App\Domain\Catalogs\Models\Catalog;
use App\Domain\Catalogs\Models\CatalogItem;
use Ensi\LaravelTestFactories\BaseModelFactory;
use Illuminate\Database\Eloquent\Model;

class CatalogsFactory extends BaseModelFactory
{
    protected $model = Catalog::class;

    public function definition(): array
    {
        return [
            'name' => $this->faker->word,
            'code' => $this->faker->unique()->regexify('[A-Za-z0-9_-]{30}'),
            'is_active' => $this->faker->boolean(),
        ];
    }

    public function withCatalogItems(?int $count = 3): self
    {
        return $this->afterCreating(function (Model $model) use ($count) {
            /** @var Catalog $model */
            CatalogItem::factory()
                ->count($count)
                ->create(['catalog_id' => $model->id]);
        });
    }
}
