<?php

namespace App\Http\ApiV1\Modules\Catalogs\Requests;

use App\Domain\Catalogs\Models\Catalog;
use App\Http\ApiV1\Support\Requests\BaseFormRequest;
use Illuminate\Validation\Rule;

class ReplaceCatalogRequest extends BaseFormRequest
{
    public function rules(): array
    {
        $catalogId = $this->route('id');

        return [
            'is_active' => ['required', 'boolean'],
            'code' => [
                'nullable',
                'string',
                'regex:/^[a-z0-9_-]+$/i',
                Rule::unique(Catalog::class, 'code')->ignore($catalogId),
            ],
            'name' => ['required', 'string'],
        ];
    }
}
