<?php

namespace App\Http\ApiV1\Modules\Catalogs\Resources;

use App\Domain\Catalogs\Models\CatalogItem;
use App\Http\ApiV1\Modules\Categories\Resources\CategoriesResource;
use App\Http\ApiV1\Support\Resources\BaseJsonResource;

/**
 * @mixin CatalogItem
 */
class CatalogItemsResource extends BaseJsonResource
{
    public function toArray($request): array
    {
        return [
            'id' => $this->id,
            'name' => $this->name,
            'code' => $this->code,
            'url' => $this->url,
            'is_active' => $this->is_active,
            'category_id' => $this->category_id,
            'catalog_id' => $this->catalog_id,
            'parent_id' => $this->parent_id,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,

            'catalog' => CatalogsResource::make($this->whenLoaded('catalog')),
            'category' => CategoriesResource::make($this->whenLoaded('category')),
        ];
    }
}
