<?php

namespace App\Http\ApiV1\Modules\Catalogs\Resources;

use App\Domain\Catalogs\Models\Catalog;
use App\Http\ApiV1\Support\Resources\BaseJsonResource;

/**
 * @mixin Catalog
 */
class CatalogsResource extends BaseJsonResource
{
    public function toArray($request): array
    {
        return [
            'id' => $this->id,
            'name' => $this->name,
            'code' => $this->code,
            'is_active' => $this->is_active,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,

            'catalog_items' => CatalogItemsResource::collection($this->whenLoaded('catalogItems')),
        ];
    }
}
