<?php

namespace App\Http\ApiV1\Modules\Catalogs\Tests\Factories;

use App\Domain\Catalogs\Models\Catalog;
use App\Domain\Catalogs\Models\CatalogItem;
use App\Domain\Categories\Models\Category;
use Ensi\LaravelTestFactories\BaseApiFactory;

class CatalogItemRequestFactory extends BaseApiFactory
{
    public function definition(): array
    {
        return [
            'name' => $this->faker->word,
            'code' => $this->faker->unique()->regexify('[A-Za-z0-9_-]{30}'),
            'is_active' => $this->faker->boolean(),
        ];
    }

    public function forCatalog(?Catalog $catalog = null): CatalogItemRequestFactory
    {
        return $this->state(['catalog_id' => $catalog->id ?? Catalog::factory()->create()->id]);
    }

    public function forCategory(?Category $category = null): self
    {
        return $this->state(['category_id' => $category->id ?? Category::factory()->create()->id]);
    }

    public function forParent(?CatalogItem $catalogItem = null): self
    {
        return $this->state(['parent_id' => $catalogItem->id ?? CatalogItem::factory()->create()->id]);
    }

    public function make(array $extra = []): array
    {
        return $this->makeArray($extra);
    }
}
